import { OnInit, Type, ViewContainerRef, ComponentFactoryResolver, ComponentRef, OnDestroy } from '@angular/core';
import { AnimationEvent } from '@angular/animations';
import { Router } from '@angular/router';
import { Subscription } from 'rxjs';
import { InputType, OverlayFunction } from './modal.service';
export interface InjectComponent {
    component: Type<any>;
    inputs: InputType;
    resolve: (value?: any | PromiseLike<any>) => void;
    reject: (reason?: any) => void;
}
export interface IModal {
    modal: ModalComponent;
}
export declare class ModalComponent implements OnInit, OnDestroy {
    private resolver;
    private router;
    injectComponent: InjectComponent;
    width: string;
    height: string;
    showOverlay: OverlayFunction;
    hideOverlay: OverlayFunction;
    viewContainerRef: ViewContainerRef;
    scaling: boolean;
    hostWidth: string;
    hostHeight: string;
    componentRef: ComponentRef<any>;
    result: any;
    subscription: Subscription;
    constructor(resolver: ComponentFactoryResolver, router: Router);
    ngOnInit(): void;
    ngOnDestroy(): void;
    close<T>(result: T): void;
    animationDone(e: AnimationEvent): void;
}
