import { ComponentFactoryResolver, Type, ApplicationRef } from '@angular/core';
export interface InputType {
    [index: string]: any;
}
export declare type OverlayFunction = () => void;
export declare class ModalService {
    private resolver;
    private applicationRef;
    private showOverlay;
    private hideOverlay;
    constructor(resolver: ComponentFactoryResolver, applicationRef: ApplicationRef);
    private readonly viewContainerRef;
    open<T>(component: Type<any>): Promise<T>;
    open<T>(component: Type<any>, inputs: InputType): Promise<T>;
    open<T>(component: Type<any>, inputs: InputType, width: string): Promise<T>;
    setOverlay(showOverlay: OverlayFunction, hideOverlay: OverlayFunction): void;
}
